/**************************************************/
/***						***/
/***	action.c				***/
/***						***/
/**************************************************/

/* gcc -ggdb -O -o robo main.c coach.c action.c util.c shmem.c -lm */

#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>

#include	"main.h"
#include	"util.h"
#include	"function.h"
#include	"flag.h"
#include	"action.h"

#ifdef		MAIN
#define		EXTERN
#else
#define         EXTERN		extern
#endif

EXTERN Obj	ball, mate[MAXPLAYER], enemy[MAXPLAYER];
EXTERN int	nmate, nenemy;

extern Obj	gMyGoal, gEnemyGoal, gFutureBall;

FLOAT		gWaitTimeBall;

void	Action(Obj *player, int command[5])
{
    Obj		*target = &gFutureBall;

    if (STOP == player[command[0]]. move) {
	Stay(&(player[command[0]]));
	return;
    }

#ifdef	PREDICTFUTURE
    target = &gFutureBall;
#endif
#ifdef	CURRENTONLY
    target = &ball;
#endif

    switch (command[1]) {
    case PRESSBALL:
	PressBall(target, &(player[command[0]]));
	break;
    case PRESSBALL2:
	PressBall2(target, &(player[command[0]]));
	break;
    case SHOOT:
	Shoot(target, &(player[command[0]]));
	break;
    case PASS:
	break;
    case DRIBBLE:
	break;
    case BLOCK:
	break;
    case GKBLOCK:
	GKBlock(&(player[command[0]]));
	break;
    case STAY:
	Stay(&(player[command[0]]));
	break;
    case WAITFW:
	WaitFWPosition(&(player[command[0]]));
	break;
    case FREESPACE:
	Run2FreeSpace(&(player[command[0]]));
	break;
    case DFPOSITION:
	GoDfPosition(target, &(player[command[0]]));
	break;
    case DFSTANDARD:
	DfStandard(&(player[command[0]]));
	break;
    case KEEPERPOSITION:
	GKPosition(&(player[command[0]]));	/* not for strategy5 */
/*	GKPosition2(&(player[command[0]]));*/	/* for strategy5 */
	break;
    case POTENTIALPRESS:
	PotentialPress(target, &(player[command[0]]));
	break;
    case PKKICK:
	FirstKick(target, &(player[command[0]]));
	break;
    case PKBLOCK:
	GKBlock(&(player[command[0]]));
	break;
    case PKBLOCKLEFT:
	GKLeft(&(player[command[0]]));
	break;
    case PKBLOCKRIGHT:
	GKRight(&(player[command[0]]));
	break;
    case CLEAR:
	Clear(target, &(player[command[0]]));
	break;
    case SIDEATTACK:
	SideAttack(target, &(player[command[0]]));
	break;
    case CENTERING:
	Centering(target, &(player[command[0]]));
	break;
    default:
	break;
    }
}

void	GKBlock(Obj *player)
{
    int		ballarea, e;
    FLOAT	xpos = 7.5, d;
    FLOAT	cx, cy;

    ballarea = BallArea();
    e = NearestBallEnemy(enemy, nenemy, &d);

// ball äưƤ뤫ޤϥ˸äƤʤ
    if (ball. speed < 10 || ball. dir < 110 || 250 < ball. dir) {
// ѡ ball ˶ᤱХꥢ
        if (Distance(player, &ball) < 20) {
	    GoXY(player, ball. x, ball. y);
	    return;
	}
// ѡ ball ΥƤ
        else {
// Ũܡ˶᤯ܡ˶ᤤϡball ˰ֶᤤŨ ball ľ˹Ԥ
            if (d < 20 && 1 == ballarea) {
	        XPoint2Lines(ball. x, ball. y, enemy[e]. x, enemy[e]. y,
			     xpos, (FLOAT)CY, xpos, (FLOAT)Y_FIELD, &cx, &cy);
	    }
// Ũܡ˶᤯ʤ ball  y ɸ˹Ԥ
            else {
	        cx = xpos; cy = ball. y;
	    }
	}
    }
// ball ®ưƤϡΥɤ
    else {
        XPointDiredPoint2Line(ball. x, ball. y, ball. dir, 
			      xpos, (FLOAT)CY, xpos, (FLOAT)Y_FIELD, &cx, &cy);
    }

    if (cy < GY1) {cy = GY1 + 5; cx = 5;}
    if (GY2 < cy) {cy = GY2 - 5; cx = 5;}
    GoXY(player, cx, cy);
}

void	GKLeft(Obj *player)
{
    GoThru(player, 200);
}

void	GKRight(Obj *player)
{
    GoThru(player, -200);
}

void	GKBlockOld(Obj *player)
{
    int		ballarea, e;
    FLOAT	xpos = 7.5, d;
    FLOAT	cx, cy;

    ballarea = BallArea();
    e = NearestBallEnemy(enemy, nenemy, &d);

// ball äưƤơ˸äƤʤ
    if (ball. speed < 10 || ball. dir < 110 || 250 < ball. dir) {
// Ũܡ˶᤯ܡ˶ᤤϡball ˰ֶᤤŨ ball ľ˹Ԥ
        if (d < 20 && (1 == ballarea || 2 == ballarea)) {
	    XPoint2Lines(ball. x, ball. y, enemy[e]. x, enemy[e]. y,
			 xpos, (FLOAT)CY, xpos, (FLOAT)Y_FIELD, &cx, &cy);
	}
// Ũܡ˶᤯ʤ ball  y ɸ˹Ԥ
	else {
	    cx = xpos; cy = ball. y;
	}
    }
// ball ®ưƤϡΥɤ
    else {
        XPointDiredPoint2Line(ball. x, ball. y, ball. dir, 
			      xpos, (FLOAT)CY, xpos, (FLOAT)Y_FIELD, &cx, &cy);
    }

    if (cy < GY1) {cy = GY1; cx = 5;}
    if (GY2 < cy) {cy = GY2; cx = 5;}
    GoXY(player, cx, cy);
}

void	GKPosition(Obj *player)
{
    FLOAT	xpos = 7.5;

/**************************************************************/
    if (10 < fabs(player -> x - xpos) || 10 < fabs(player -> y - CY)) {
/**************************************************************/
	GoXY(player, xpos, (FLOAT)CY);
	return;
    }
    if (15 < fabs(player -> dir - 270))
	TurnAbsDir(player, 270.0);
}

void	GKPosition2(Obj *player) /* for strategy5 */
{
    FLOAT	xpos = 10.0;

/*  if (DistanceFromXY(player -> x, player -> y, xpos, CY) < ALLOWERRDIS)*/
    if (20 < player -> x)
	GoXY(player, xpos, (FLOAT)CY);
    else if (15 < fabs(player -> dir - 270))
	TurnAbsDir(player, 270.0);
    else 
        GKBlock(player);
}

void	Run2FreeSpace(Obj *player)
{
    if (gFutureBall. y < Y_FIELD / 4 || Y_FIELD * 3 / 4 < gFutureBall. y) 
        GoXY(player, 200, CY);
    else if (gFutureBall. y < CY) 
        GoXY(player, 200, Y_FIELD * 2 / 3);
    else
        GoXY(player, 200, Y_FIELD / 3);
}

void	WaitFWPosition(Obj *player)
{
    if (ball. x < CX - 30 || ball. x < CX + 30 ||
	ball. y < CY - 25 || ball. y < CY + 25)
        GoXY(player, CX, CY);
    else {
        if (ball. y < CY) GoXY(player, CX, CY + 30);
	else              GoXY(player, CX, CY - 30);
    }
}

int	PreventMultipleOfRobots(FLOAT *x, FLOAT *y)
{
    return(NO);
}

int	PreventMultipleDfRobots(FLOAT *x, FLOAT *y)
{
    if (*x < PENALTYX + 5) {
	*x = PENALTYX + 20;
	return(YES);
    }
/*
    if (YES == PenaltyAreaXY(*x, *y, MYSIDE)) {
	*x = PENALTYX + 1;
	*y = ball -> y < PENALTYY1 ? PENALTYY1 : ball -> y;
	*y = PENALTYY2 < *y ? PENALTYY2 : *y;
	return(YES);
    }
*/
    return(NO);
}

void	GoDfPosition(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    if (ball -> x < X_FIELD / 5) {
//	DfPosition(player, ball, &x, &y);
        GoXY(player, 30, ball->y<CY?CY+15:CY-15);
	return;
    }
    else
	DfWaitPosition(player, ball, &x, &y);

    PreventMultipleDfRobots(&x, &y);

    if (DistanceFromXY(x, y, player -> x, player -> y) < ALLOWERRDIS ||
	Dir(player, ball) < 20 || 340 < Dir(player, ball))
	GoXYThru(player, ball -> x, ball -> y);
    else {
        GoXY(player, x, y);
    }
}

void	DfStandard(Obj *player)
{
    GoXY(player, X_FIELD / 4, CY);
}

int	CanIKick(Obj *ball, Obj *player, FLOAT x, FLOAT y)
{
    FLOAT	bx = ball -> x, by = ball -> y;
    FLOAT	px = player -> x, py = player -> y;
    FLOAT	cx, cy;
    FLOAT       adeg, adis, frontgoal = 0.66;

    if (bx < X_FIELD - 30) {
      adeg = ALLOWERRDEG;
      adis = ALLOWERRDIS;
    }
    else {
      adeg = ALLOWERRDEG * frontgoal; // goal mae ha seikaku ni
      adis = ALLOWERRDIS * frontgoal;
    }
    XPoint2Lines(px, py, bx, by, X_FIELD, 0, X_FIELD, Y_FIELD, &cx, &cy);

    if (bx < px) return(NO);

    if (fabs(Dir(player, ball) - DirFromXY(x, y, bx, by)) < adeg ||
	DistanceFromXY(x, y, px, py) < adis ||
	(GY1 <= cy && cy <= GY2) ||
	fabs(Dir(player, ball) - Dir(ball, &gEnemyGoal)) < 20) {
        return(YES);
    }
    return(NO);
}

void	PressBall(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    if (CX < ball -> x) OfPosition(player, ball, &x, &y);
    else		DfPosition(player, ball, &x, &y);

    PreventMultipleDfRobots(&x, &y);

    if (YES == CanIKick(ball, player, x, y)) {
	GoXYThru(player, ball -> x, ball -> y);
    }
    else {
        GoXY(player, x, y);
/*
	tmp. x = x;
	tmp. y = y;
	if (YES == Inside2Objs(ball, player, &tmp)) {
	    if (ball -> y < CY) 
		GoArc(player, ROTATERIGHT, x, y, Dir(player, &tmp));
	    else
		GoArc(player, ROTATELEFT, x, y, Dir(player, &tmp));
	}
	else {
	    GoXY(player, x, y);
	}
*/
    }
}

void	PressBall2(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    if (CX < ball -> x) OfPosition(player, ball, &x, &y);
    else		DfPosition(player, ball, &x, &y);

    if (x < CX - 40) {
        x += -10;
	y += y<CY?30:-30;
    }
    else {
        x += -30;
	y += y<CY?10:-10;
    }

    PreventMultipleDfRobots(&x, &y);

    GoXY(player, x, y);
}

void	SideAttack(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    x = ball -> x - 12.5;
    y = ball -> y < CY ? 14 : Y_FIELD - 14;

    PreventMultipleDfRobots(&x, &y);

    if (YES == CanIKick(ball, player, x, y))
	GoXYThru(player, ball -> x, ball -> y);
    else {
        GoXY(player, x, y);
    }
}

void	Centering(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    x = ball -> x - 2.5;
    y = ball -> y;
    if (y < 10) y = 10;
    if (Y_FIELD - 10 < y) y = Y_FIELD - 10;

    if (YES == CanIKick(ball, player, x, y))
	if ((y < Y_FIELD / 4 || Y_FIELD * 3 / 4 < y) &&
	    DistanceFromXY(x, y, player -> x, player -> y) < 2.0)
	    if (y < CY) TurnRelDir(player, 90);
            else        TurnRelDir(player, -90);
        else 
	    GoXYThru(player, ball -> x, ball -> y);
    else {
        GoXY(player, x, y);
    }
}

void	Clear(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    x = ball -> x;
    y = ball -> y + 10;
    if (CY < ball -> y) y = ball -> y - 10;

    PreventMultipleDfRobots(&x, &y);

    if (DistanceFromXY(x, y, player -> x, player -> y) < ALLOWERRDIS)
	if ((y < Y_FIELD / 4 || Y_FIELD * 3 / 4 < y) &&
	    DistanceFromXY(x, y, player -> x, player -> y) < 2.0)
	    if (y < CY) TurnRelDir(player, 90);
            else        TurnRelDir(player, -90);
        else 
	    GoXYThru(player, ball -> x, ball -> y);
    else {
	GoXY(player, x, y);
    }
}

void	PotentialPress(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    DiredPoint(ball -> x, ball -> y, NormalDir(DownDirOfPotential(ball) + 180), 
	       10.0, &x, &y);

    PreventMultipleDfRobots(&x, &y);

    if (YES == CanIKick(ball, player, x, y))
	GoXYThru(player, ball -> x, ball -> y);
    else {
        GoXY(player, x, y);
    }
}

void	Shoot(Obj *ball, Obj *player)
{
    FLOAT	x, y;

    ShootPosition(player, ball, enemy, nenemy, &x, &y);
/*
    if (DistanceFromXY(x, y, player -> x, player -> y) < ALLOWERRDIS)
*/
    if (YES == CanIKick(ball, player, x, y))
	GoXYThru(player, ball -> x, ball -> y);
    else {
        GoXY(player, x, y);
    }
}

void	FirstKick(Obj *ball, Obj *player)
{
    GoThru(player, 500);
}
