#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <locale.h>
#include "main.h"

#define MARK_SIZE                14

unsigned long MyColor(char *);

Display *d;
XImage *img1, *img2;
Visual *vis1;
Window w;
XSetWindowAttributes att;
GC gc1;
XEvent e;
Colormap cmap;
XColor color[65536];
Font f1;
unsigned long orange, yellow, blue, green;

extern int WIDTH,HEIGHT;
extern unsigned char *yuv, *yuv422, **image;
extern unsigned short *pdata16,*pdata16glay;


unsigned long MyColor(char *lo_color){
  XColor c0,c1;

  XAllocNamedColor(d, cmap, lo_color, &c1 , &c0);
  return(c1.pixel);
}


void create_window()
{
  d=XOpenDisplay(NULL);
  vis1=DefaultVisual(d,0);
  w = XCreateSimpleWindow(d,DefaultRootWindow(d),0,0,WIDTH*2,HEIGHT,
                          4,BlackPixel(d,0),WhitePixel(d,0));
  XStoreName(d, w, "Video");
  XSetIconName(d, w, "Video");
  att.backing_store = Always;
  XChangeWindowAttributes(d,w,CWBackingStore,&att);
  XSelectInput(d,w,StructureNotifyMask);
  XMapWindow(d,w);
  XSelectInput(d,w, ButtonPressMask | Button1MotionMask );
  gc1=XCreateGC(d,w,0,0);
  cmap = DefaultColormap(d,0);
  orange = MyColor("orange");
  yellow = MyColor("yellow");
  blue   = MyColor("blue");
  green  = MyColor("green");
  f1 = XLoadFont(d, "-adobe-helvetica-bold-r-normal--11-*-75-75-p-*-*-1");

  img1=XCreateImage(d,vis1,DefaultDepth(d,0),ZPixmap,0,0,WIDTH,HEIGHT,16,0);
  img1->data           = (char *)pdata16;
  img2=XCreateImage(d,vis1,DefaultDepth(d,0),
                    ZPixmap,WIDTH,0,WIDTH,HEIGHT,16,0);
  img2->data           = (char *)pdata16glay;
  XSync(d,False);

}


void xdisplay()
{
  XPutImage(d,w,gc1,img1,0,0,0,0,WIDTH,HEIGHT);
  XPutImage(d,w,gc1,img2,0,0,WIDTH,0,WIDTH,HEIGHT);
  XFlush(d);
}


void Marked_Pozition(){
  int i;
  char s[8];

  XSetForeground( d, gc1, orange);
  XSetLineAttributes(d,gc1,1,LineSolid,CapRound,JoinRound);
#if 1
  XDrawArc(d,w,gc1,Tr_ball.x-(MARK_SIZE/2),Tr_ball.y-(MARK_SIZE/2),
  MARK_SIZE,MARK_SIZE,0,360*64);
#endif
  XSetForeground( d, gc1, yellow /* blue */ );
#if 1
  for( i = 0; i< MAX_ROBO_NO;i++){ 
    XDrawArc(d,w,gc1,Tr_mate[i].x-(MARK_SIZE/2),Tr_mate[i].y-(MARK_SIZE/2),
             MARK_SIZE,MARK_SIZE,0,360*64);
    XDrawLine( d, w, gc1, Tr_mate[i].x ,Tr_mate[i].y ,
    Tr_mate[i].x + (Tr_mate[i].x - Tr_mate[i].dirx),
    Tr_mate[i].y + (Tr_mate[i].y - Tr_mate[i].diry)  );
    XSetFont(d,gc1,f1);
    sprintf(s,"%d",i+1);
    XDrawString(d,w,gc1,Tr_mate[i].x+(MARK_SIZE/2)+4,
                Tr_mate[i].y+(MARK_SIZE/2)+4,s,1);
  }
  XFlush(d);
#endif
#if 1
  XSetForeground( d, gc1, blue  );
  for( i = 0; i< MAX_ENEMY_NO;i++){
    XDrawArc(d,w,gc1,Tr_enemy[i].x-(MARK_SIZE/2),Tr_enemy[i].y-(MARK_SIZE/2),
             MARK_SIZE,MARK_SIZE,0,360*64);
  }
  XFlush(d);
#endif

#if 0
  XSetForeground( d, gc1,blue  );
  for( i = 0; i< MAX_ROBO_NO;i++){
    XDrawArc(d,w,gc1,testdispxx[i]-(MARK_SIZE/2),testdispyy[i]-(MARK_SIZE/2),
             MARK_SIZE,MARK_SIZE,0,360*64);
  }
  XFlush(d);
  XSetForeground( d, gc1,green  );
  for( i = 0; i< MAX_ROBO_NO;i++){
    XDrawArc(d,w,gc1,testdispx[i]-(MARK_SIZE/2),testdispy[i]-(MARK_SIZE/2),
             MARK_SIZE,MARK_SIZE,0,360*64);
  }
  XFlush(d);
#endif

}

void yuv2rgb16()
{
  register int j;
  unsigned char y1, u, y2, v, *p1;
  unsigned short *p2,r;

  for(j=0, p1=yuv422, p2=pdata16; j<WIDTH*HEIGHT/2; j++, p1+=4, p2+=2) {
    y1 = p1[0]; v  = p1[1]; y2 = p1[2]; u  = p1[3];
    r = (unsigned short)y1 & 0xf8;
    p2[0] = (r << 8) + (r << 3) +(r >> 3) ;
    r = (unsigned short)y2 & 0xf8;
    p2[1] = (r << 8) + (r << 3) +(r >> 3) ;
  }


}

void image2rgb16()
{
  int i,j;
  unsigned char no;
  unsigned short *p2,r,g,b;
  extern unsigned char *bdata1;

  for(i=0,p2=pdata16glay;i<HEIGHT;i++){
    for(j=0; j<WIDTH; j++, p2++) {
      no = image[i][j];
      
      if( bdata1[i*WIDTH+j] != 255 ){
	if(no == 1){r = 255&0xf8; g = 165&0xf8; b = 0&0xf8; }//ball
	else if(no == 1<<1){r = 255&0xf8; g = 255&0xf8; b =   0&0xf8; }//mate
	else if(no == 1<<2){r =   0&0xf8; g =   0&0xf8; b = 255&0xf8; }//enemy
	else if(no == 1<<3){r =   0&0xf8; g = 191&0xf8; b = 255&0xf8; }//blue
	else if(no == 1<<4){r = 255&0xf8; g =   0&0xf8; b =   0&0xf8; }//red
	else if(no == 1<<5){r =   0&0xf8; g = 255&0xf8; b =   0&0xf8; }//green
	else{ r = 0; g = 0; b = 0; }
	}
      else{ r = 0; g = 0; b = 0; }

      p2[0] = (r << 8) + (g << 3) +(b >> 3) ;
    }
  }
}


void switch_on()
{ 
  if(XCheckTypedEvent(d, ButtonPress, &e)){
    if(e.xany.window == w){
      printf("(x ,y)=%3d,%3d\n",e.xbutton.x,e.xbutton.y);
    }
  }
}


