/**************************************************/
/***						***/
/***	function.h				***/
/***						***/
/**************************************************/

void	NextBallPosition(Obj *ball, FLOAT time, FLOAT *x, FLOAT *y, FLOAT *dir);
void	NextObjPosition(Obj *obj, FLOAT time, FLOAT *x, FLOAT *y, FLOAT *dir);
int	FarFromField(FLOAT x, FLOAT y);
int	OutOfField(FLOAT x, FLOAT y);
int	OutOfX(FLOAT x);
int	OutOfY(FLOAT y);
FLOAT   NormalX(FLOAT x);
FLOAT   NormalY(FLOAT y);
void	RotateXY(FLOAT x, FLOAT y, FLOAT degree, FLOAT cx, FLOAT cy, FLOAT *nx, FLOAT *ny);
FLOAT	D2R(FLOAT degree);
FLOAT	R2D(FLOAT radian);
int	XYArea(FLOAT x, FLOAT y);
int	TouchLine(FLOAT px, FLOAT py, FLOAT x, FLOAT y, FLOAT *tx, FLOAT *ty, FLOAT *vtime);
FLOAT	ReflectDir(FLOAT dir, int linecode);
FLOAT	NormalDir(FLOAT dir);	/* 0 -- 360 */
FLOAT	Dir180(FLOAT dir);	/* -180 -- 180 */
FLOAT	SqrDistance(Obj *obj1, Obj *obj2);
FLOAT	SqrDistanceFromXY(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2);
FLOAT	Distance(Obj *obj1, Obj *obj2);
FLOAT	DistanceFromXY(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2);
FLOAT	Dir(Obj *obj1, Obj *obj2);
FLOAT	DirFromXY(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2);
void	DiredPoint(FLOAT x, FLOAT y, FLOAT dir, FLOAT distance, FLOAT *nx, FLOAT *ny);
int	XPoint4Objs(Obj *obj1, Obj *obj2, Obj *obj3, Obj *obj4, FLOAT *cx, FLOAT *cy);
int	XPoint2Lines(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2, FLOAT x3, FLOAT y3, FLOAT x4, FLOAT y4, FLOAT *cx, FLOAT *cy);
int	XPointDiredPoint2Line(FLOAT x1, FLOAT y1, FLOAT dir, FLOAT x2, FLOAT y2, FLOAT x3, FLOAT y3, FLOAT *cx, FLOAT *cy);
void	XPointPoint2Line(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2, FLOAT x3, FLOAT y3, FLOAT *cx, FLOAT *cy);
int	LineParam(FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2, FLOAT *a, FLOAT *b);
int	FieldStatus(int ballarea, int area[]);
void	AllObjArea(int ary[]);
int	BallArea(void);
int	ObjArea(Obj *obj);
int     PenaltyArea(Obj *obj, int side);
int	PenaltyAreaXY(FLOAT x, FLOAT y, int side);
void    ShootPosition(Obj *player, Obj *ball, Obj *enemy, int nenemy, FLOAT *x, FLOAT *y);
void	OfPosition(Obj *player, Obj *obj, FLOAT *x, FLOAT *y);
void	DfPosition(Obj *player, Obj *obj, FLOAT *x, FLOAT *y);
void	DfWaitPosition(Obj *player, Obj *obj, FLOAT *x, FLOAT *y);
FLOAT	BallDir(Obj *obj);
FLOAT	FutureBallDir(Obj *obj);
FLOAT	BallDistance(Obj *obj);
FLOAT	FutureBallDistance(Obj *obj);
void	OrderBallPlayer(Obj *obj, int num, int a[], FLOAT d[]);
void	OrderFutureBallPlayer(Obj *obj, int num, int a[], FLOAT d[]);
int     WhoisBestKicker(Obj *player, FLOAT dist[], FLOAT x, FLOAT y);
Obj*	NearestBallRobot(Obj *mate, Obj *enemy, int nmate, int nenemy, FLOAT *distance);
int     NearestObjPlayer(Obj *player, Obj *obj, int num, FLOAT *distance);
int	NearestBallMate(Obj *obj, int num, FLOAT *distance);
int	NearestFutureBallMate(Obj *obj, int num, FLOAT *distance);
int	NearestBallEnemy(Obj *obj, int num, FLOAT *distance);
int	NearestFutureBallEnemy(Obj *obj, int num, FLOAT *distance);
int	AroundBall(FLOAT r, int *matenum, int *enemynum);
int     InsideAllRobots(Obj *player, Obj *point);
int	Inside2Objs(Obj *target, Obj *obj1, Obj *obj2);
int	InsideXY(FLOAT tx, FLOAT ty, FLOAT x1, FLOAT y1, FLOAT x2, FLOAT y2);
void	AvoidCollisionBall(Obj *player, FLOAT *x, FLOAT *y);
void	AvoidCollisionAll(Obj *player, FLOAT *x, FLOAT *y);
int	AvoidCollisionObj(Obj *player, Obj *obs, FLOAT *x, FLOAT *y, FLOAT *dir);
void	InitVar(Obj *ball, Obj *mate, Obj *enemy, int nmate, int nenemy);
void	ReadInitData(char fname[], Obj *ball, Obj *mate, Obj *enemy, int *nmate, int *nenemy);
int	SetObjVal(Obj *obj, FLOAT ary[]);
void	GoArc(Obj *obj, int rotate, FLOAT x, FLOAT y, FLOAT dir);
void	GoXY(Obj *obj, FLOAT x, FLOAT y);
void	GoXYThru(Obj *obj, FLOAT x, FLOAT y);
void    GoThru(Obj *obj, int distance);
void	GoAbsDir(Obj *obj, FLOAT dir, FLOAT distance);
void	GoRelDir(Obj *obj, FLOAT dir, FLOAT distance);
void	Go(Obj *obj, FLOAT distance);
void	TurnRelDir(Obj *obj, FLOAT dir);
void	TurnAbsDir(Obj *obj, FLOAT dir);
void	Nop(Obj *obj);
void	Stay(Obj *obj);
void	StopRobot(void);
void    Setgo_dist_mm(int fd, int no, int n);
void    Setrotate_theta(int fd, int no, int n);
void    Setrotate_and_go(int fd, int no, int theta, int dist);
void    Setarc(int fd, int no, int dir, int radius, int leng);
void	Setnop(int fd, int no);
void	SendCmdList(void);
void    Print2TeamLog(Obj *bptr, Obj *mptr, Obj *eptr, CmdList *mlist, CmdList *elist, int time);
void    PrintTeamLog(Obj *bptr, Obj *mptr, Obj *eptr, CmdList *list, int time);
void    PrintMotionLog(Obj *bptr, Obj *mptr, Obj *eptr, int time);
void    PrintTeamObjPosition(Obj *ptr);
void    PrintObjPosition(Obj *ptr);
void    PrintTeamCmdList(CmdList *ptr);
void    PrintCmdList(CmdList *ptr);
void	PrintTeamReadableCmdList(CmdList *ptr);
void	PrintReadableCmdList(CmdList *ptr);
int	Token(char str[], FLOAT num[]);
int	TestDigit(char str[]);

void	HeadCoachInit(void);
void	HeadCoach(int mode);
void    HeadCoachOld(void);
void    HeadCoachTest(void);
void	StrategyPKKick(int command[][5]);
void    StrategyPKBlock(int command[][5]);
void    StrategyPKBlockLeft(int command[][5]);
void    StrategyPKBlockRight(int command[][5]);
void    Strategy1(int command[][5]);
void    Strategy52a(int command[][5]);
void    Strategy52(int  command[][5]);
void    Strategy51(int  command[][5]);
void    Strategy5test(int command[][5]);
void    StrategyNtest(int command[][5]);
void    StrategyPtest(int command[][5]);
void    StrategyP52(int command[][5]);
void    StrategyP51(int command[][5]);
void    Strategy31(int  command[][5]);
void    Strategy32(int  command[][5]);
void    MoveTest(int mode);
void	RestPlayer1(Obj *player, int num, int id[], FLOAT d[], int side, int status, int command[]);
void	RestPlayer2(Obj *player, int num, int id[], FLOAT d[], int side, int status, int command[]);
int	SelectPress(int ballarea);

void	Action(Obj *player, int command[5]);
void	GKBlock(Obj *player);
void	GKLeft(Obj *player);
void	GKRight(Obj *player);
void	GKBlockOld(Obj *player);
void	GKPosition(Obj *player);
void	GKPosition2(Obj *player);
void	Run2FreeSpace(Obj *player);
void	WaitFWPosition(Obj *player);
int	PreventMultipleOfRobots(FLOAT *x, FLOAT *y);
int	PreventMultipleDfRobots(FLOAT *x, FLOAT *y);
void	GoDfPosition(Obj *ball, Obj *player);
void	DfStandard(Obj *player);
int     CanIKick(Obj *ball, Obj *player, FLOAT x, FLOAT y);
void	PressBall(Obj *ball, Obj *player);
void	PressBall2(Obj *ball, Obj *player);
void	SideAttack(Obj *ball, Obj *player);
void	Centering(Obj *ball, Obj *player);
void	Clear(Obj *ball, Obj *player);
void	PotentialPress(Obj *ball, Obj *player);
void    Shoot(Obj *ball, Obj *player);
void	FirstKick(Obj *ball, Obj *player);

void    GetPotentialField(Obj *mate, Obj *enemy, int nmate, int nenemy);
void    MakeStaticPotentialField(void);
void    CalcDynamicPotentialField(FLOAT field[PX][PY], Obj *mate, Obj *enemy, int nmate, int nenemy);
void    AddPlayerPotential(Obj  *player, FLOAT field[PX][PY], int flag);
FLOAT   Potential(Obj   *obj1, Obj *obj2, int flag);
FLOAT   SqrtDPotential(Obj   *obj1, Obj *obj2, int flag);
FLOAT   DownDirOfPotential(Obj  *ball);
FLOAT   PotentialGradient(FLOAT x, FLOAT y, int dir);
FLOAT   ApproxPotential(FLOAT   x, FLOAT y);
void    CopyPotentialField(void *src, void *dst, int xsize, int ysize);
void    SavePotentialField(char filename[], FLOAT field[PX][PY]);
void    SaveLocalPotentialField(char filename[], FLOAT field[PX][PY], Obj *player);
