#define __EYE5_MAIN__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <gtk/gtk.h>
#include <sys/time.h>
#include <unistd.h>

#include "main.h"
#include "interface.h"
#include "support.h"

typedef void*(*pthread_start)(void *);

void initialize(void);
int bound(int);
void file_read(char *);
void file_read1(char *);
void file_read2(char *);
int device_open(char *, int *, int, int, int );
void device_close(int *);

void create_window(void);
void glay2rgb16(void);
void yuv2rgb16(void);
void rgb242rgb16(void);
void image2rgb16(void);
void xdisplay(void);
void switch_on(void);
void Marked_Pozition(void);
void test();

void Main_Loop(void);
void Frame_Loop(void);
void Gtk_Loop(void);
void Display_Loop(void);
void get_image(int *);
void threshold(void);
void image_processing(void);

void PredictByCmd(void);
void PredictFileRead(char *);

int Back_Formation(void);

void Mode_Check();
void HeadCoach(int) ;

void trans4any();

int WIDTH  = 999;
int HEIGHT = 999;
int video;
int color_no;

double sec = 1.0;
int first= 1;

struct threshold thresh;

unsigned char *yuv, *yuv422, *bdata1;
unsigned char **image, **label_image;
unsigned short *pdata16, *pdata16glay;
int color_size[8];

void Nyuryoku(int *);

int main(int argc, char *argv[]){

  pthread_t thread1, thread2, thread3;
  
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  if(argc>2) { WIDTH=atoi(argv[1]); HEIGHT=atoi(argv[2]); }
  else { WIDTH = X_SIZE; HEIGHT = Y_SIZE;}
  
  initialize();

  file_read("colors.txt");
  file_read1("setup.txt");
  file_read2("setup.pgm");
  PredictFileRead("predict.txt");

  create_window();

  pthread_create(&thread1,NULL,(pthread_start)Frame_Loop,NULL);
  pthread_create(&thread2,NULL,(pthread_start)Display_Loop,NULL);
  pthread_create(&thread3,NULL,(pthread_start)Gtk_Loop,NULL);

  Main_Loop();
  
  device_close(&video);
  
  return 0;
}

void Main_Loop()
{
  struct timeval t1,t2;

  while(1){
    gettimeofday(&t1,NULL);
    image_processing();
    
    trans4any();
    
    //    printf("pre(%3f,%3f,%3f)\n",mate[0].x,mate[0].y,mate[0].dir);
    PredictByCmd();
    //    printf("nex(%3f,%3f,%3f)\n",mate[0].x,mate[0].y,mate[0].dir);
    //    printf("\n");
    
    image2rgb16();
  

    //test();
    

    
    Mode_Check();

    if( gtk_g_2 == 5 ){

      //test_robot_go100();      /* ǥХåޥ   */
      //printf("mode: %d\n",mode);

      if(first == 1){ HeadCoach(first); first = 0; sleep(1);}
      
      else if(first == 2){ 
	if((ball.x-ball.px)<1 && (ball.y-ball.py)<1){ HeadCoach(first); }
	else{first = 0; }
      }
      else if(first == 3){
	HeadCoach(first); first = 2; sleep(1);
      }
      else if(first == 4){
	HeadCoach(first); first = 2; sleep(1);
      }
      else if(first == 10){
	printf("OK_FORMQTION\n");
	if(Back_Formation() == 1) {first = 111;}
	else{sleep(1);}
      }
      else if(first == 111){
	printf("formation\n");
	if(Back_Formation() != 1) {first = 10;}
	
      }
      else{
	HeadCoach(51);
      }
      //usleep(500000);
      usleep(400000);
      //usleep(350000);
      //usleep(300000); //1.7 fps
      //usleep(250000);  //2 fps      
      //usleep(200000);  //2 fps
      //usleep(100000);
      
#if 0
      printf("Tr_ball :%.0f %.0f\n",Tr_ball.x,Tr_ball.y);
      printf("ball    :%.0f %.0f\n",ball.x,ball.y);
      for(i=0;i<5;i++){
	printf("id = %d\n",i);
	printf("Tr_mate :%.0f %.0f\n",Tr_mate[i].x,Tr_mate[i].y);      
	printf("Tr_enemy:%.0f %.0f\n",Tr_enemy[i].x,Tr_enemy[i].y);
	printf("mate    :%.0f %.0f\n",mate[i].x,mate[i].y);
	printf("enemy   :%.0f %.0f\n",enemy[i].x,enemy[i].y);
      }

#endif
    }

    gettimeofday(&t2,NULL);        
    sec = (t2.tv_sec - t1.tv_sec) + (t2.tv_usec - t1.tv_usec) / 1E6;
    //fprintf(stderr,"Elapsed time: %4.3fs (%ffps)\n",sec,1 / sec); 
      
  }
}

void Frame_Loop()
{ 
  
  double sec;
  struct timeval t1,t2;
  
  while(1){  

    gettimeofday(&t1,NULL);
    get_image(&video);
    threshold();
    gettimeofday(&t2,NULL);
    sec = (t2.tv_sec - t1.tv_sec) + (t2.tv_usec - t1.tv_usec) / 1E6;
    //fprintf(stderr,"Elapsed time: %4.3fs (%ffps)\n",sec,1 / sec);
  }
}

void Display_Loop()
{
  double sec;
  struct timeval t1,t2;
  
  while(1){
    gettimeofday(&t1,NULL);
    yuv2rgb16();
    xdisplay();
    switch_on();
    Marked_Pozition();    
    gettimeofday(&t2,NULL);
    sec = (t2.tv_sec - t1.tv_sec) + (t2.tv_usec - t1.tv_usec) / 1E6;
    //fprintf(stderr,"Elapsed time: %4.3fs (%ffps)\n",sec,1 / sec);
  }
}

void Gtk_Loop()
{
  GtkWidget *window1;
  window1 = create_eye5 ();
  gtk_widget_show (window1);
  gtk_main ();
}

void initialize()
{
  int ok;
  int i;
  
  /* display init */
  image= (unsigned char **)malloc(HEIGHT*sizeof(unsigned char *));
  for(i=0;i<HEIGHT;i++){
    image[i]=(unsigned char *)malloc(WIDTH*sizeof(unsigned char));
    memset(image[i],0,sizeof(unsigned char)*WIDTH);
  }

  label_image = (unsigned char **)malloc(HEIGHT*sizeof(unsigned char *));
  for(i=0;i<HEIGHT;i++){
    label_image[i] = (unsigned char *)malloc(WIDTH*sizeof(unsigned char));
    memset(label_image[i],0,sizeof(unsigned char)*WIDTH);
  }

  pdata16    =(unsigned short *)malloc(WIDTH*HEIGHT*sizeof(unsigned short));
  memset(pdata16,0,WIDTH*HEIGHT*sizeof(unsigned short));
  pdata16glay=(unsigned short *)malloc(WIDTH*HEIGHT*sizeof(unsigned short));
  memset(pdata16glay,0,WIDTH*HEIGHT*sizeof(unsigned short));
  yuv422     =(unsigned char *)malloc(WIDTH*HEIGHT*2*sizeof(unsigned char));
  memset(yuv422,0,WIDTH*HEIGHT*sizeof(unsigned char));
  bdata1     =(unsigned char *)malloc(WIDTH*HEIGHT*sizeof(unsigned char));
  memset(bdata1,0,WIDTH*HEIGHT*sizeof(unsigned char));


  /* threshold init */
  thresh.y=(unsigned char *)malloc(HIST_SIZE*sizeof(unsigned char));
  memset(thresh.y,0,sizeof(unsigned char)*HIST_SIZE);
  thresh.u=(unsigned char *)malloc(HIST_SIZE*sizeof(unsigned char));
  memset(thresh.u,0,sizeof(unsigned char)*HIST_SIZE);
  thresh.v=(unsigned char *)malloc(HIST_SIZE*sizeof(unsigned char));
  memset(thresh.v,0,sizeof(unsigned char)*HIST_SIZE);

  /* device init */
  ok = device_open("/dev/video", &video, DIN, WIDTH, HEIGHT);
  if(!ok){ printf("Capture init failed.\n"); exit(1);}
  

  nmate  = GL_MATE_ROBO;
  nenemy = GL_ENEMY_ROBO;
  gtk_b_1 = 0;
  gtk_b_2 = 0;
  gtk_b_3 = 0;
  gtk_g_1 = 0;
  gtk_g_2 = 0;

  Tr_ball.x = (int)WIDTH/2;
  Tr_ball.y = (int)HEIGHT/2;

#if 1  
  for( i = 0; i < MAX_ROBO_NO ; i++){
    if( team_coat == 0 ){
      Tr_mate[i].x = (int)3*(WIDTH/4);
      Tr_mate[i].y = (int)HEIGHT/2;
      
    }
    else{
      Tr_mate[i].x = (int)1*(WIDTH/4);
      Tr_mate[i].y = (int)HEIGHT/2;
    }
  }
#endif

  for( i = 0; i < MAX_ROBO_NO ; i++){
    mate[i].move = MOVE;
  }

}

void file_read(char *filename)
{
  FILE *fp;
  char buff[256];
  int r, g, b, rh, gh, bh;
  int i;
  unsigned char Y, Cr,Cb;
  extern int color_size[8];

  if((fp = fopen( filename , "r" )) == NULL){
    fprintf(stderr,"file can not open.\n");
    exit(0);
  }

  color_no = 0;
  while(fgets(buff,256,fp) != NULL){
    if( buff[0] != '#'){
      if(color_no <= 7){
        if( buff[0] == '('){
          sscanf(buff,"(%d,%d,%d:%d,%d,%d",
                 &r,&g,&b,&rh,&gh,&bh);

          Y  =(unsigned char)( (0.257 * r) + (0.504 * g) + (0.098 * b) + 16);
          Cr =(unsigned char)( (0.439 * r) - (0.368 * g) - (0.071 * b) + 128);
          Cb =(unsigned char)(-(0.148 * r) - (0.291 * g) + (0.439 * b) + 128);
          

          //printf("%3d %3d %3d:%3d %3d %3d\n",r,g,b,rh,gh,bh);
#if 0
          fprintf(stderr,": %3d %3d %3d ",Y,Cr,Cb);
          fprintf(stderr,", %3d-%3d %3d-%3d %3d-%3d\n"
                 ,Y-rh,Y+rh,Cr-gh,Cr+gh,Cb-bh,Cb+bh);
#endif    
      
          for(i=bound(Y-rh);i<=bound(Y+rh);i++)
            thresh.y[i]=(1<<color_no)+thresh.y[i];
          for(i=bound(Cr-gh);i<=bound(Cr+gh);i++)
            thresh.u[i]=(1<<color_no)+thresh.u[i];
          for(i=bound(Cb-bh);i<=bound(Cb+bh);i++)
            thresh.v[i]=(1<<color_no)+thresh.v[i];    
	  


#if 0
          printf(": %3d %3d %3d ",Y,Cr,Cb);
          printf(", %3d-%3d %3d-%3d %3d-%3d\n"
                 ,Y-rh,Y+rh,Cr-gh,Cr+gh,Cb-bh,Cb+bh);
          for(i=0;i<HIST_SIZE;i++)
            printf("(%3d) %2d%s",i,thresh.y[i],(i%10==0)?"\n":"");
          printf("\n");
          printf(": %3d %3d %3d ",Y,Cr,Cb);
          printf(", %3d-%3d %3d-%3d %3d-%3d\n"
                 ,Y-rh,Y+rh,Cr-gh,Cr+gh,Cb-bh,Cb+bh);
          for(i=0;i<HIST_SIZE;i++)
            printf("(%3d) %2d%s",i,thresh.u[i],(i%10==0)?"\n":"");
          printf("\n");
          printf(": %3d %3d %3d ",Y,Cr,Cb);
          printf(", %3d-%3d %3d-%3d %3d-%3d\n"
                 ,Y-rh,Y+rh,Cr-gh,Cr+gh,Cb-bh,Cb+bh);
          for(i=0;i<HIST_SIZE;i++)
            printf("(%3d) %2d%s",i,thresh.v[i],(i%10==0)?"\n":"");
          printf("\n");
#endif
        }
	else if(buff[0] == '<'){
	  sscanf(buff,"<%d,%d,%d,%d,%d,%d,%d,%d"
		 ,&color_size[0],&color_size[1],&color_size[2]
		 ,&color_size[3],&color_size[4],&color_size[5]
		 ,&color_size[6],&color_size[7]);
	  //fprintf(stderr,"%d %d %d %d %d %d %d %d\n",color_size[0],color_size[1],color_size[2],color_size[3],color_size[4],color_size[5],color_size[6],color_size[7]);
	  
	}
	else{
          fprintf(stderr,"error in enter.\n");
        }
      }
      else{
        fprintf(stderr,"threshold full.\n");
        exit(0);
      }

      color_no++;
    }
  }
  fclose(fp);
}

int bound(int n)
{
  if(n <   0) n =   0;
  if(n > 255) n = 255;
  return n;
}


void file_read1(char *filename)
{
  FILE  *fp_setup;
  int n_banme = 1;
  char buf[255];
  
  if((fp_setup = fopen(filename, "r" )) == NULL){
    fprintf(stderr,"file can not open.\n");
    exit(0);
  }

  while( fgets(buf,255,fp_setup) != NULL ){
    if( buf[0] != '#' ){
      if(  n_banme == 1 ){
	/* ̣     : 0  : 1  */
	sscanf( buf, "%d", &team_coat );
	//printf("%d\n",team_coat );
	n_banme++;
      }
      else if( n_banme == 2 ){
	/*   Xɸ                  */
        sscanf( buf, "%d", &coat_left );
	//printf("%d\n",coat_left );
        n_banme++;
      }
      else if( n_banme == 3 ){
	/*   Xɸ                  */
        sscanf( buf, "%d", &coat_right );
	//printf("%d\n",coat_right );
        n_banme++;
      }
      else if( n_banme == 4 ){
	/*   Yɸ                  */
        sscanf( buf, "%d", &coat_high );
	//printf("%d\n",coat_high );
        n_banme++;
      }
      else if( n_banme == 5 ){
	/*   Yɸ                  */
        sscanf( buf, "%d", &coat_bottom );
	//printf("%d\n",coat_bottom );
        n_banme++;
      }
      else if( n_banme == 6 ){
	/*  ɸ                  */
        sscanf( buf, "%d" "%d", &x2 , &y2 );
        //printf( "%d %d \n", x2,y2 );
        n_banme++;
      }
      else if( n_banme == 7 ){
	/* ֤Υ ԥ        */
        sscanf( buf, "%d" "%d", &hosei_x2 , &hosei_y2 );
        n_banme++;
        //printf( "%d %d \n", hosei_x2,hosei_y2 );
      }
      else if( n_banme == 8 ){
	/*  ɸ                  */
        sscanf( buf, "%d" "%d",&x4 , &y4  );
        n_banme++;
        //printf( "%d %d \n", x4,y4 );
      }
      else if( n_banme == 9 ){
	/* ֤Υ챦 ԥ        */
        sscanf( buf, "%d" "%d", &hosei_x4 , &hosei_y4 );
        n_banme++;
        //printf( "%d %d \n", hosei_x4,hosei_y4 );
      }
      
    }
  }
}

void file_read2(char *filename){
  int cmax,xsize,ysize;
  char s[257];
  FILE *fp;
  
  if((fp=fopen(filename,"r")) == NULL){
    fprintf(stderr,"Error: %s ץǤޤ\n",filename);
  }
  fgets(s,256,fp);
  if(s[0] != 'P' && s[1] != '5'){
    fprintf(stderr,"Error: %s ΥեޥåȤ㤤ޤ\n",filename);
  }
  do{
    fgets(s,256,fp);
  }while(s[0] == '#');
  sscanf(s,"%d%d",&xsize,&ysize);

  if(xsize != WIDTH || ysize != HEIGHT){
    fprintf(stderr,"Error: %s Υ᡼Υ㤤ޤ\n",filename);
  }
  do{
    fgets(s,256,fp);
  }while(s[0] == '#');
  sscanf(s,"%d\n",&cmax);
  fread(bdata1,sizeof(unsigned char),(WIDTH)*(HEIGHT),fp);
  fclose(fp); 
  
}

void test()
{
  FILE *fp;
  unsigned char rgbdata[WIDTH*HEIGHT];
  int i;
  
  for(i=0;i<WIDTH*HEIGHT;i++){
    if(pdata16glay[i]>0)rgbdata[i]=255;
    else{rgbdata[i]=0;}
  }
 
  if((fp=fopen("setup.pgm","w")) == NULL){
    printf("file can not open..\n");
  }
  fprintf(fp,"P5\n");
  fprintf(fp,"%d %d\n",WIDTH,HEIGHT);
  fprintf(fp,"255\n");
  fwrite(rgbdata,sizeof(unsigned char),(WIDTH)*(HEIGHT),fp);
  fclose(fp);
}










