#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include "main.h"

#define DISTANCE          200
#define DIR             360
//#define DIR               90
#define D_SPEED           800
#define N_SPEED           400

#define GO_MOVE           1
#define DONTMOVE          0
#define JUGEDIST          5.0         
#define MOVESPEED         10
#define PI                3.14159265358979323846
#define IGNOREDIR         2.0
#define MAXMOVEDIST       20
#define MOVEFINISH        1
#define ALLFINISH         MAX_ROBO_NO

typedef struct cmd_list MoveCmd;

void MoveTest_Dash(int ,int);
void MoveTest_Rotate(int);
void MoveTestRotateandGo(int,int,int);
void image_processing();
void trans4any();
void f5call(int,MoveCmd*);

double NormalDir_M(double);
double DistanceFromXY_M(double, double, double, double);
double Dir180_M(double);
double R2D_M(double);
double DirFromXY_M(double, double, double, double);
void MoveAction(int);
int EndFlag(void);
int Back_Formation(void);
void ObjectPoint(void);
void Transform(int, int ,double *,double *);
void Position_Read(char *);


struct ObjPosition MovePoint[MAX_ROBO_NO];
MoveCmd mCmdList[MAX_ROBO_NO]; 
int moveflag[MAX_ROBO_NO];
int flag;

typedef struct MovePosition{
  int x;
  int y;
};

struct MovePosition Tr_MovePoint[MAX_ROBO_NO];

void Move_Go(int no,int dist,int speed)
{
  mCmdList[no].cmd='g';
  mCmdList[no].para[0]=(short)dist;
  mCmdList[no].para[1]=0;
  mCmdList[no].para[2]=(short)speed;
}

void Move_Rotate(int no, int dir)
{
  mCmdList[no].cmd='d';
  mCmdList[no].para[0]=(short)dir;
  mCmdList[no].para[1]=0;
  mCmdList[no].para[2]=0;
}

void Move_RotateandGo(int no, int dir, int dist, int speed)
{
  mCmdList[no].cmd='j';
  mCmdList[no].para[0]=(short)dir;
  mCmdList[no].para[1]=(short)dist;
  mCmdList[no].para[2]=(short)speed;
}

void MMoveTest()
{
  int i;
  double pdir=0;
  
  
  image_processing();
  trans4any();
  printf("%f,%f,%f\n",mate[3].x,mate[3].y,mate[3].dir);
  pdir = mate[0].dir;
  

  for(i=0;i<MAX_ROBO_NO;i++){
    //Move_Go(i,DISTANCE, N_SPEED);
    Move_Rotate(i,DIR);
    //Move_RotateandGo(i,DIR, DISTANCE, N_SPEED);
  }

  f5call(fd, mCmdList);

  usleep(400000);

  image_processing();
  trans4any();
  printf("%f,%f,%f\n",mate[3].x,mate[3].y,mate[3].dir);
  printf("%f\n",NormalDir_M(mate[4].dir-pdir));

}

#if 1

double NormalDir_M(double dir)
{
    if (dir < 0) return(dir + 360);
    if (360 <= dir) return(dir - 360);
    return(dir);
}

double DistanceFromXY_M(double x1, double y1, double x2, double y2)
{
  return fabs((sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1))));
} 

double Dir180_M(double dir)
{
  if(dir <= 180) return(dir);
  else return(360 - dir);

}

double R2D_M(double radian)
{
    return(radian / PI * 180.0);
}

double DirFromXY_M(double x1, double y1, double x2, double y2)
{
    if (fabs(x1 - x2) < 0.0001) {
        if (y1 < y2) return(90.0);
        else         return(270.0);
    }
    if (x1 < x2)
        return(NormalDir_M(R2D_M(atan((y2 - y1) / (x2 - x1)))));
    else
        return(NormalDir_M(180.0 - R2D_M(atan((y2 - y1) / -(x2 - x1)))));
}


void MoveAction(int no)
{
  double dir;
  double theta;
  double dist;

  dir = DirFromXY_M(mate[no].x,mate[no].y,MovePoint[no].x,MovePoint[no].y);
  dist = DistanceFromXY_M(mate[no].x,mate[no].y,MovePoint[no].x,MovePoint[no].y);

  if(dir > IGNOREDIR){
    theta = Dir180_M(NormalDir_M(dir - mate[no].dir));
    if(dist > MAXMOVEDIST)
      Move_RotateandGo(no, (int)theta, (int)(MAXMOVEDIST * 10), (int)N_SPEED);
    else
      Move_RotateandGo(no, (int)theta, (int)(dist * 10), (int)N_SPEED);
  }
  else{
    if(dist > MAXMOVEDIST)
      Move_Go(no, (int)(MAXMOVEDIST * 10), (int)N_SPEED);
    else
      Move_Go(no, (int)(dist * 10), (int)N_SPEED);
  }
}

int EndFlag()
{
  if((moveflag[0] * moveflag[1] * moveflag[2] * moveflag[3] * moveflag[4]) == 1)return(1);
  else return(0);
}

int Back_Formation()
{
  int i;

  if(EndFlag() == 1) return(1);

  for(i=0;i<MAX_ROBO_NO;i++){
    if(DistanceFromXY_M(mate[i].x, mate[i].y, MovePoint[i].x, MovePoint[i].y) > JUGEDIST && moveflag[i] == 0)
      MoveAction(i);
    else{
      Move_Go(i,0,MOVESPEED);
      moveflag[i] = 1;
    }
  }
  
  f5call(fd,mCmdList);

  return(0);
}

void ObjectPoint()
{
  int i;

  Position_Read("position.txt");
  
  for(i=0;i<MAX_ROBO_NO;i++){
    Transform(Tr_MovePoint[i].x, Tr_MovePoint[i].y, 
	      &MovePoint[i].x, &MovePoint[i].y);
    printf("%f,%f\n",MovePoint[i].x, MovePoint[i].y);
  }
  for(i=0;i<MAX_ROBO_NO;i++)
    moveflag[i] = 0;
  
  flag = 0;
}

void Transform(int trx ,int try ,double *x ,double *y)
{
  if( trx < coat_left ) trx = coat_left;
  else if( trx > coat_right ) trx = coat_right;
  if( try < coat_high ) try = coat_high;
  else if( try > coat_bottom ) try = coat_bottom;
  if( team_coat == 0 ){
    *x = X_FIELD *( ((double)trx-coat_left)/(coat_right-coat_left) );
    *y = Y_FIELD *( ((double)try-coat_high)/(coat_bottom-coat_high) );
  }
  else{
    *x = (0.5+X_FIELD - (X_FIELD *( ((double)trx-coat_left)/
                               (coat_right-coat_left) )));
    *y = (0.5+Y_FIELD - (Y_FIELD *( ((double)try-coat_high)/
                              (coat_bottom-coat_high) )));
  }
}

void Position_Read(char *filename)
{
  FILE *fp;
  int n_banme = 1;
  char buf[255];

  if((fp = fopen(filename, "r" )) == NULL){
    fprintf(stderr,"file can not open.\n");
    exit(0);
  }

  while( fgets(buf,255,fp) != NULL ){
    if( buf[0] != '#' ){
      if(  n_banme == 1 ){
        sscanf( buf, "%d" "%d", &Tr_MovePoint[0].x, &Tr_MovePoint[0].y);
        printf("%d %d\n",Tr_MovePoint[0].x, Tr_MovePoint[0].y);
        n_banme++;
      }
      else if( n_banme == 2 ){
        sscanf( buf, "%d" "%d", &Tr_MovePoint[1].x, &Tr_MovePoint[1].y);
        printf("%d %d\n",Tr_MovePoint[1].x, Tr_MovePoint[1].y);
        n_banme++;
      }
      else if( n_banme == 3 ){
        sscanf( buf, "%d" "%d", &Tr_MovePoint[2].x, &Tr_MovePoint[2].y);
        printf("%d %d\n",Tr_MovePoint[2].x, Tr_MovePoint[2].y);
        n_banme++;
      }
      else if( n_banme == 4 ){
        sscanf( buf, "%d" "%d", &Tr_MovePoint[3].x, &Tr_MovePoint[3].y);
        printf("%d %d\n",Tr_MovePoint[3].x, Tr_MovePoint[3].y);
        n_banme++;
      }
      else if( n_banme == 5 ){
        sscanf( buf, "%d" "%d", &Tr_MovePoint[4].x, &Tr_MovePoint[4].y);
        printf("%d %d\n",Tr_MovePoint[4].x, Tr_MovePoint[4].y);
        n_banme++;
      }
    }
  }
}
#endif



