#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"

#define MAX_RECORD           3  /*  */
#define FRAMSEC              0.06667
#define PRETIME              FRAMSEC




typedef struct cmd_list         CmdList;
extern CmdList         gCmdList[5];
extern double sec;

double normal_speed;
double dash_speed;
double rotate_speed;
double omomi;

void PredictByCmd(void);
void Calc_GoDist(int,int,double,double);
void Calc_Rotate(int,int,double,double);
void Calc_Rotate_and_Go(int,int,int,double,double,double);
double NormalDir_p(double);
void PredictFileRead(char *);

void PredictByCmd()
{
  int no;

  for(no=0;no<MAX_ROBO_NO;no++){
//    if(no==0){
      switch(gCmdList[no].cmd){
      case 'g':
	//printf("g:%d,%d\n",no, gCmdList[no].para[0]);
	Calc_GoDist(no, gCmdList[no].para[0], PRETIME, dash_speed);
	break;
      case 'd':
	//printf("d:%d,%d\n",no, gCmdList[no].para[0]);
	Calc_Rotate(no, gCmdList[no].para[0], PRETIME, rotate_speed);
	break;
      case 'j':
	//printf("j:%d,%d,%d\n",no, gCmdList[no].para[0], gCmdList[no].para[1]);
	Calc_Rotate_and_Go(no, gCmdList[no].para[0], gCmdList[no].para[1],
			   PRETIME, normal_speed, rotate_speed);
	break;
      default:
	break;
      }
//    }
  }
}


void Calc_GoDist(int no, int pdist, double pre_time, double n_speed)
{
  double dist=0.0;
  double nor_time;

  nor_time = fabs((double)pdist) / 10.0 / n_speed * omomi;
  
  if(nor_time < pre_time) dist = (double)pdist / 10.0;
  else  dist = pre_time * n_speed * omomi;

  if(pdist >= 0){
    mate[no].x = mate[no].x + cos(mate[no].dir) * dist;
    mate[no].y = mate[no].y + sin(mate[no].dir) * dist;
  }
  else{
    mate[no].x = mate[no].x + cos(NormalDir_p(mate[no].dir+180.0)) * dist;
    mate[no].y = mate[no].y + sin(NormalDir_p(mate[no].dir+180.0)) * dist;
  }

  //printf("%d go_dist(%f,%f)\n",no,(cos(mate[no].dir) * dist),
  // (sin(mate[no].dir) * dist));
}


void Calc_Rotate(int no, int pdir, double pre_time, double r_speed)
{
  double dir=0.0;
  double rot_time;

  rot_time = fabs((double)pdir) / r_speed * omomi;
  
  if(rot_time < pre_time)  dir = (double)pdir;
  else   dir = pre_time * r_speed * omomi;
  
  if(pdir >= 0){
    mate[no].dir += dir;
    mate[no].dir = NormalDir_p(mate[no].dir);
  }
  else{
    mate[no].dir -= dir;
    mate[no].dir = NormalDir_p(mate[no].dir);
  }

//printf("%d rotate(%f)\n",no,dir);
}


void Calc_Rotate_and_Go(int no, int pdir, int pdist, double pre_time, 
			double n_speed, double r_speed)
{
  double rot_time;
  double nor_time;
  double com_time;
  double dir=0.0;
  double dist=0.0;

  rot_time = fabs((double)pdir) / r_speed * omomi;
  nor_time = fabs((double)pdist) / 10.0 / n_speed * omomi;

  //printf("%f, %f\n",rot_time,nor_time);
  //printf("%f\n",pre_time);

  if((com_time = rot_time + nor_time) < pre_time){
    if(pdir >= 0){
      mate[no].dir += pdir;
      mate[no].dir = NormalDir_p(mate[no].dir);
    }
    else{
      mate[no].dir -= dir;
      mate[no].dir = NormalDir_p(mate[no].dir);
    }
    if(pdist >= 0){
      mate[no].x = mate[no].x + cos(mate[no].dir) * pdist / 10.0;
      mate[no].y = mate[no].y + sin(mate[no].dir) * pdist / 10.0; 
    }
    else{
    mate[no].x = mate[no].x + cos(NormalDir_p(mate[no].dir+180.0)) * pdist / 10;
    mate[no].y = mate[no].y + sin(NormalDir_p(mate[no].dir+180.0)) * pdist / 10;
    }
    //printf("%d rotate_and_go1(%f,%f)\n",no,(cos(mate[no].dir) * pdist),
    //   (sin(mate[no].dir) * pdist));
  }
  else{
    if(rot_time > pre_time){
      dir = pre_time * r_speed * omomi;
      if(pdir >= 0){
	mate[no].dir += dir;
	mate[no].dir = NormalDir_p(mate[no].dir);
      }
      else{
	mate[no].dir -= dir;
	mate[no].dir = NormalDir_p(mate[no].dir);
      }
      //printf("%d rotate_and_go2(%f)\n",no,dir);
    }
    else{
      dist = (pre_time - rot_time) * n_speed * omomi;
      if(pdir >= 0){
	mate[no].dir += pdir;
	mate[no].dir = NormalDir_p(mate[no].dir);
      }
      else{
	mate[no].dir -= dir;
	mate[no].dir = NormalDir_p(mate[no].dir);
      }
      if(pdist >= 0){
	mate[no].x = mate[no].x + cos(mate[no].dir) * dist;
	mate[no].y = mate[no].y + sin(mate[no].dir) * dist;
      }
      else{
	mate[no].x = mate[no].x + cos(NormalDir_p(mate[no].dir+180.0)) * dist;
	mate[no].y = mate[no].y + sin(NormalDir_p(mate[no].dir+180.0)) * dist;
      }
      //printf("%d rotate_and_go3(%f,%f)\n",no,(cos(mate[no].dir) * dist),
      //     (sin(mate[no].dir) * dist));
    }    
  }
}


double NormalDir_p(double dir)
{
    if (dir < 0) return(dir + 360);
    if (360 <= dir) return(dir - 360);
    return(dir);
}


void PredictFileRead(char *filename)
{
  FILE  *fp;
  int n_banme = 1;
  char buf[255];
  
  if((fp = fopen(filename, "r" )) == NULL){
    fprintf(stderr,"file can not open.\n");
    exit(0);
  }

  while( fgets(buf,255,fp) != NULL ){
    if( buf[0] != '#' ){
      if(  n_banme == 1 ){
        /* NORMALSPEED */
	//	fgets(buf,255,fp);
	normal_speed = atof(buf);
	//printf("R_NPEED=%f\n",normal_speed);
        n_banme++;
      }
      else if( n_banme == 2 ){
        /* DASHSPEED */
	//fgets(buf,255,fp);
	dash_speed = atof(buf);
	//printf("R_DASH=%f\n",dash_speed);
        n_banme++;
      }
      else if( n_banme == 3 ){
        /* ROTATE */
	//fgets(buf,255,fp);
	rotate_speed = atof(buf);
	//printf("R_ROTATE=%f\n", rotate_speed);
        n_banme++;
      }
      else if( n_banme == 4 ){
        /* DASHSPEED */
	//fgets(buf,255,fp);
	omomi = atof(buf);
	//printf("OMOMI=%f\n",omomi);
        n_banme++;
      }
    }
  }
}

