#include <stdio.h>
#include "main.h"
#include "serial.h"

#include "prottype.h"

void set_retry_number(int fd , int retry){
  int i;
  char da[25];

  sprintf(da,"@RNO%03d\r\n",retry);

  write(fd,&da,9);
  fprintf(stderr,"DBG:sr:");
  for(i=0;i<9;i++) fprintf(stderr,"%3x",da[i]&0xFF);
  fprintf(stderr,"\n");
  if(get_response(fd)<0) return;
}


int get_response(int fd){
  char buff[16];
  int retcode;

LBL1:
  tread(fd,buff,4);
  if(buff[0]=='P') {
    if(buff[1]=='0') {
      retcode=1;
    } else {
      if(buff[1]=='1') {
        goto LBL1;
      } else {
        retcode=-1;
      }
    }
  } else {
    retcode=-1;
  }
  buff[4]=0;
  fprintf(stderr,"DBG:buff:%s",buff);
  return retcode;
}


void wait_ack(int fd){
  char buff[4];

  tread(fd, buff, 1);
}


void f5call(int fd,struct cmd_list cmd[]){
  int size;
  int BCC;
  char send_data[128];

  int robo_no;
  int i,j;

  BCC = 0;
  size=43;
  robo_no = 0x3a;
  BCC ^= robo_no;
  BCC ^= 'n';

  for(i=0;i<5;i++){
    BCC ^= ' ';
    BCC ^= cmd[i].cmd;
    for(j=0;j<3;j++){
      BCC ^= cmd[i].para[j]&0xFF;
      BCC ^= (cmd[i].para[j]>>8)&0xFF;
    }
  }

  sprintf(send_data,
          "@TBN255%03d%cn %c%c%c%c%c%c%c %c%c%c%c%c%c%c %c%c%c%c%c%c%c %c%c%c%c%c%c%c %c%c%c%c%c%c%c%c\r\n"
	            , size , robo_no
          ,cmd[0].cmd
          ,(char)(cmd[0].para[0]>>8)&0xFF , (char)cmd[0].para[0]&0xFF
          ,(char)(cmd[0].para[1]>>8)&0xFF , (char)cmd[0].para[1]&0xFF
          ,(char)(cmd[0].para[2]>>8)&0xFF , (char)cmd[0].para[2]&0xFF

          ,cmd[1].cmd
          ,(char)(cmd[1].para[0]>>8)&0xFF , (char)cmd[1].para[0]&0xFF
          ,(char)(cmd[1].para[1]>>8)&0xFF , (char)cmd[1].para[1]&0xFF
          ,(char)(cmd[1].para[2]>>8)&0xFF , (char)cmd[1].para[2]&0xFF

          ,cmd[2].cmd
          ,(char)(cmd[2].para[0]>>8)&0xFF , (char)cmd[2].para[0]&0xFF
          ,(char)(cmd[2].para[1]>>8)&0xFF , (char)cmd[2].para[1]&0xFF
          ,(char)(cmd[2].para[2]>>8)&0xFF , (char)cmd[2].para[2]&0xFF

          ,cmd[3].cmd
          ,(char)(cmd[3].para[0]>>8)&0xFF , (char)cmd[3].para[0]&0xFF
          ,(char)(cmd[3].para[1]>>8)&0xFF , (char)cmd[3].para[1]&0xFF
          ,(char)(cmd[3].para[2]>>8)&0xFF , (char)cmd[3].para[2]&0xFF

          ,cmd[4].cmd
          ,(char)(cmd[4].para[0]>>8)&0xFF , (char)cmd[4].para[0]&0xFF
          ,(char)(cmd[4].para[1]>>8)&0xFF , (char)cmd[4].para[1]&0xFF
          ,(char)(cmd[4].para[2]>>8)&0xFF , (char)cmd[4].para[2]&0xFF

          ,(char)BCC&0xFF
          );

  /*
  fprintf(stderr, "ޥ : %c %c %c %c %c\n", 
	  cmd[0].cmd , cmd[1].cmd , cmd[2].cmd , cmd[3].cmd , cmd[4].cmd );
  fprintf(stderr, "para : %d %d %d %d %d\n", 
	  cmd[0].para[0], cmd[1].para[0] , cmd[2].para[0] , cmd[3].para[0] , cmd[4].para[0] );
  fprintf(stderr, "para1 : %d %d %d %d %d\n", 
	  cmd[0].para[1], cmd[1].para[1] , cmd[2].para[1] , cmd[3].para[1] , cmd[4].para[1] );
  */
  /*for(i = 0;i<55;i++) printf("%3x ",send_data[i]);
  puts("");*/
  write(fd,&send_data,55);
  if(get_response(fd)<0)return;
}





