#define __OWARIBITO_SERIAL__
#include "main.h"
#include "serial.h"

#include "prottype.h"
int wait_flag=S_TRUE;


void signal_handler_IO (int status){
  wait_flag = S_FALSE;
}


void OpenSerial(int *fd){
  *fd = open(SERIALPORT, O_RDWR | O_NOCTTY | O_NONBLOCK );
  if (*fd < 0) {perror(SERIALPORT); exit(-1);}

  saio.sa_handler = signal_handler_IO;
  /*saio.sa_mask = 0;*/
  saio.sa_flags = 0;
  saio.sa_restorer = NULL;
  sigaction(SIGIO,&saio,NULL);
  fcntl(*fd, F_SETOWN, getpid());
  fcntl(*fd, F_SETFL, FASYNC);
  tcgetattr(*fd, &oldtio);
  newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = IGNPAR | ICRNL;
  newtio.c_oflag = 0;
  newtio.c_lflag = 0;
  newtio.c_cc[VMIN]=0;
  newtio.c_cc[VTIME]=0;
  tcflush(*fd, TCIFLUSH);
  tcsetattr(*fd,TCSANOW,&newtio);
}


void CloseSerial(int fd){
    tcsetattr(fd, TCSANOW, &oldtio);
}


void get_Robo_Status(int fd){
  char Se_buf[8];

  while(1){
    read(fd , Se_buf , 1);
    if(Se_buf[0] == ETX){
      read(fd , Se_buf , 2);
      break;
    }
  }
}


void init_modem(int fd){
  fprintf(stderr,"DBG:enter init_modem\n");
  /*Dump Register (Debug porpuse)*/
  modem_show_reg(fd,0);   /*my address (=0) */
  modem_show_reg(fd,18);  /*communication mode 1 (=3DH) */
  modem_show_reg(fd,19);  /*communication mode 2 (=0) */
  modem_show_reg(fd,20);  /*interface 1 (=6) */
  modem_show_reg(fd,22);  /*interface 3 (=0) */

  /*Clear buffer*/
  modem_bcl(fd);
}


void fifo_in(char *t_buff, int *wptr, int *tlen,
             char *buff, int nread){
  int i;

  if(*tlen>=T_BUFF_LENG) { /*drop input chars*/
    return;
  } else {
    for(i=0;i<nread;i++) {
      t_buff[*wptr]= buff[i];
      *wptr= *wptr+1; *tlen= *tlen+1; 
      if(*wptr==T_BUFF_LENG) *wptr=0;
      if(*tlen==T_BUFF_LENG) break; /*drop remaining chars*/
    }
  }
}


char get_char_fifo(char *t_buff, int *rptr, int *tlen){
  char chr;

  chr= t_buff[*rptr];
  *rptr= *rptr+1; if(*rptr==T_BUFF_LENG) *rptr=0;
  *tlen= *tlen-1;
  return(chr);
}


