#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "main.h"

#define min(x,y) ( (x) >= (y)? (y) : (x) )

//#define MAXLABEL   ((X_SIZE/2)*(Y_SIZE/2)+4)
#define MAXLABEL   ((640/2)*(480/2)+4)

#define MAXSIZE                 100      /* ٥  */
#define MINSIZE                  25      /* ޡȤεΥ */
#define MARKERSIZE               45      /* ޡ礭 */
#define MINSUM                    5      /* object.sum[] 礭 */

            
//#define MINSIZE                  10      /* ޡȤεΥ */
//#define MARKERSIZE               12      /* ޡ礭 */
//#define MINSUM                    1      /* object.sum[] 礭 */

int nlabel(int , int );
void labelsort(void);
void label(unsigned char, unsigned char);

void ball_tokutei(void);
void mate_tokutei(void);
void confidence_coefficient(int, int, int);
void enemy_tokutei(void);


struct Object{
  double x[MAXSIZE];
  double y[MAXSIZE];
  int sum[MAXSIZE];
};


int label_table[MAXLABEL+1];
int maxlabel;

struct Object object[MAX_ROBO_NO+3];

extern int WIDTH,HEIGHT;
extern unsigned char  **image, **label_image;

extern struct ObjPosition_Tr Tr_ball, Tr_mate[MAX_ROBO_NO];

void threshold()
{
  register int i,j;
  register unsigned char *p, y1, y2, u, v;
  register unsigned char th1, th2;
  
  extern unsigned char *yuv422, *bdata1;
  extern struct threshold thresh;

  for(i=0,p=yuv422;i<HEIGHT;i++){
    for(j=0;j<WIDTH;j+=2,p+=4){
      y1 = p[0]; y2 = p[2]; u  = p[3]; v  = p[1];

      if( bdata1[i*WIDTH+j] != 255 ){
      th1=thresh.y[p[0]]&thresh.u[p[3]]&thresh.v[p[1]];
      th2=thresh.y[p[2]]&thresh.u[p[3]]&thresh.v[p[1]];
      
      if( th1>0 ){ image[i][j  ]=th1; }
      else{ image[i][j  ]=0; }
      if( th2>0 ){ image[i][j+1]=th2; }
      else{ image[i][j+1]=0; }
      }
      else{ image[i][j  ]=0; image[i][j+1]=0; }
    }
  }
  
}

void image_processing()
{
  register int i;
  extern int color_no;


  for(i=0;i<color_no;i++)
    label( 1<<i ,i);  
  ball_tokutei();
  mate_tokutei();
  enemy_tokutei();

}

void label(unsigned char no, unsigned char id)
{
  register int i, j, max=0;
  int sum[MAXSIZE];
  double sum_x[MAXSIZE], sum_y[MAXSIZE];
  
  maxlabel = 0;
  for(i=1;i<HEIGHT-1;i++){
    for(j=1;j<WIDTH-1;j++){
      if(image[i][j]==no){
        label_image[i][j]=nlabel(j,i);
      }
      else{
        label_image[i][j]=0;
      }
    }
  }
  
  labelsort();
  
  memset(sum,0,sizeof(int)*MAXSIZE);
  memset(sum_x,0,sizeof(double)*MAXSIZE);
  memset(sum_y,0,sizeof(double)*MAXSIZE);
  
  for(i=1;i<HEIGHT-1;i++){
    for(j=1;j<WIDTH-1;j++){
      if(label_image[i][j]>0){
        label_image[i][j] = label_table[label_image[i][j]];
	if(label_image[i][j] < MAXSIZE){
	  sum[label_image[i][j]]++;
	  sum_x[label_image[i][j]]+=(double)j;
	  sum_y[label_image[i][j]]+=(double)i;
	}
	else{ fprintf(stderr,"MAXSIZE OVER id = %d\n",id); }
      }
    }
  }  

  if( id<8 ){
    max=0;
    for(i=1;i<MAXSIZE;i++){
      if((sum[i]>MINSUM) && (max<MAXSIZE)){
	object[id].x[max]   = (sum_x[i]/sum[i]);
	object[id].y[max]   = (sum_y[i]/sum[i]);
	object[id].sum[max] = sum[i];
	max++;
      } 
    }
    for(i=max;i<MAXSIZE;i++){
      object[id].x[i]   = -1;
      object[id].y[i]   = -1;
      object[id].sum[i] = -1;      
    }

#if 0
    if(id == 3){
      for(i=0;i<10;i++){
	//printf("(%.1f,%.1f) ",object[id].x[i],object[id].y[i]);
	//printf("(%.0f,%.0f) ",sum_x[i]/sum[i],sum_y[i]/sum[i]);
	//printf("%3d(%3d) ",sum[i],object[id].sum[i]);
	printf("%3d ",object[id].sum[i]);
      }
      printf("\n");
    }
#endif
  }
}

void mate_tokutei()
{
  register int i, j, k, no;
  register int min_x, min_dir;
  double kyori, min;

  //printf("%.0f %.0f %.0f %.0f %.0f\n",object[1].x[0],object[1].x[1],object[1].x[2],object[1].x[3],object[1].x[4]);

  for(k=0;k<MAX_ROBO_NO;k++){
    Tr_mate[k].px = Tr_mate[k].x;
    Tr_mate[k].py = Tr_mate[k].y;
    min_x=-1; min_dir=-1;

    for(i=0;i<MAXSIZE;i++){
      min=MINSIZE;
      if(object[1].x[i] != -1){
	for(j=0;j<MAXSIZE;j++){
	  if(k < 3){
	    if((object[k+3].x[j]!= -1) && (object[k+3].sum[j] < MARKERSIZE)){
	      kyori = ( fabs(object[1].x[i]-object[k+3].x[j])
			+ fabs(object[1].y[i]-object[k+3].y[j]) );
	    }
	    else { kyori = 1000;  }
	  }
	  else{
	    if((object[k].x[j]!= -1) && (object[k].sum[j] > MARKERSIZE)){
	      kyori = ( fabs(object[1].x[i]-object[k].x[j])
			+ fabs(object[1].y[i]-object[k].y[j]) );
	    }
	    else { kyori = 1000;  }
	  }
	  
	  if(kyori < min){
	    min     = kyori;
	    min_x   = i;
	    min_dir = j;
	  }
	}
      }
    }  
    //printf("%d %d %d\n",k,min_x,min_dir);
    if( (min_x!=-1) && (min_dir!=-1) ){
    if(k<3) { no = k+3; }
      else{ no = k; }
      Tr_mate[k].x = object[1].x[min_x];
      Tr_mate[k].y = object[1].y[min_x];
      Tr_mate[k].dirx = object[no].x[min_dir];
      Tr_mate[k].diry = object[no].y[min_dir];
      
      /*    */
      confidence_coefficient(k,object[1].sum[min_x],object[no].sum[min_dir]);
      
    }
    else{
      confidence_coefficient(k,0,0);
    }
  }
}

void confidence_coefficient(int id,int team_color, int sub_color)
{
  double team, sub;
  extern int color_size[8];
  extern struct ObjPosition mate[5];
  
  team = 1.0 - fabs(1-((double)team_color/color_size[1]));
  sub  = 1.0 - fabs(1-((double)sub_color/color_size[id+3]));
  
  mate[id].cfxy  = team;
  mate[id].cfdir = min(team,sub);
  //fprintf(stderr,"%d cfxy=%.2f cfdir=%.2f\n",id,mate[id].cfxy,mate[id].cfdir);
}

void enemy_tokutei()
{
  int i, max, pos, x, y;
 
  for(i=0;i<MAX_ENEMY_NO;i++){
    Tr_enemy[i].px  = Tr_enemy[i].x;
    Tr_enemy[i].py  = Tr_enemy[i].y;
  }
  max=0;
  for(i=0;i<MAXSIZE;i++){
    x = (int)object[2].x[i] - 20;
    y = (int)object[2].y[i] - 20;
    pos = (x&(~1))*2+WIDTH*y*2;

    if((object[2].sum[i]>MINSUM) && (max<MAX_ROBO_NO)){
      Tr_enemy[max  ].x = (object[2].x[i]);
      Tr_enemy[max++].y = (object[2].y[i]);
    }
  }
}



void ball_tokutei()
{
  int i, no, max;
  
  Tr_ball.px = Tr_ball.x;
  Tr_ball.py = Tr_ball.y;
  max=0; no = 0;
  
  for(i=0;i<MAXSIZE;i++){
    if( max < object[0].sum[i] ){
      max = object[0].sum[i];
      no = i;
    }
  }
  if( 0 < max){
    Tr_ball.x = object[0].x[no];
    Tr_ball.y = object[0].y[no];
  }
}


void labelsort()
{
  int i,j,l,pl;
  
  for(i=0;i<maxlabel;i++){
    if(label_table[i]!=i){
      l=i;
      while(label_table[l]!=l){
        l=label_table[l];
      }
      label_table[i]=l;
    }
  }
  for(i=0,l=0;i<=maxlabel;i++){
    if((pl=label_table[i])>l){
      l++;
      for(j=i;j<=maxlabel;j++){
        if(label_table[j]==pl)
          label_table[j]=l;
      }
    }
  }
  maxlabel=l;

}

int nlabel(int x0, int y0)
{
  int i,label=0,fvalue;
  int dirx[]={-1,0,1,-1},diry[]={-1,-1,-1,0};
  
  for(i=0;i<4;i++){
    if((fvalue=label_image[y0+diry[i]][x0+dirx[i]])>0){
      if(label==0){
        label=fvalue;
      }
      else if(fvalue<label){
        label_table[label]=fvalue;
        label=fvalue;
      }
      else if(fvalue>label){
        label_table[fvalue]=label;
      }
    }
  }
  if(label==0){
    label=++maxlabel;
    if(label>MAXLABEL){
      return (-1);
    }
    label_table[label]=label;
  }
  return (label);
}











