#include <math.h>
#include <stdio.h>
#include "main.h"


#define PI 3.14159265358979323846
#define SPEED_K   0.5          /* ®٤٤η */

void henkan(double ,double ,double * ,double *);

double NormalDir__a(double dir){
    if (dir < 0) return(dir + 360);
    if (360 <= dir) return(dir - 360);
    return(dir);
}


double R2D__a(double radian){
    return(radian / PI * 180.0);
}


double DirFromXY__a(double x1, double y1, double x2, double y2){
  if (fabs(x1 - x2) < 0.001) {
    if (y1 < y2) return(90.0);
    else         return(270.0);
  }
  if (x1 < x2){
    return (NormalDir__a(R2D__a(atan((y2 - y1) / (x2 - x1)))));
  }
  else{
    return(NormalDir__a(180.0 - R2D__a(atan((y2 - y1) / -(x2 - x1)))));
  }
}



double hosei_x( int x ){
  double r=0;

  r=1.0*(x-x2)/(x4-x2)*hosei_x4+1.0*(x-x4)/(x2-x4)*hosei_x2;

  return r;
}

double hosei_y( int y){
  double r=0;
  
  r=1.0*(y-y2)/(y4-y2)*hosei_y4+1.0*(y-y4)/(y2-y4)*hosei_y2;

  return r;
}


void trans4any(){
  int i;
  extern double sec;
  
  henkan(Tr_ball.x , Tr_ball.y , &ball.x , &ball.y);
  henkan(Tr_ball.px , Tr_ball.py , &ball.px , &ball.py);
  ball.dir = 0;
  ball.speed = sqrt((ball.x-ball.px)*(ball.x-ball.px)
		    +(ball.y-ball.py)*(ball.y-ball.py)) / sec;
  ball.dir =  DirFromXY__a(ball.x, ball.y, ball.px, ball.py);

  for(i=0;i<MAX_ROBO_NO;i++){
    
    Tr_mate[i].x  = Tr_mate[i].x - (int)hosei_x(Tr_mate[i].x);
    Tr_mate[i].y  = Tr_mate[i].y - (int)hosei_y(Tr_mate[i].y);
    henkan(Tr_mate[i].x , Tr_mate[i].y , &mate[i].x , &mate[i].y);
    
    Tr_mate[i].px  = Tr_mate[i].px - (int)hosei_x(Tr_mate[i].px);
    Tr_mate[i].py  = Tr_mate[i].py - (int)hosei_y(Tr_mate[i].py);
    henkan(Tr_mate[i].px , Tr_mate[i].py , &mate[i].px , &mate[i].py);
    
    Tr_mate[i].dirx  = Tr_mate[i].dirx - (int)hosei_x(Tr_mate[i].dirx);
    Tr_mate[i].diry  = Tr_mate[i].diry - (int)hosei_y(Tr_mate[i].diry);
    
    mate[i].speed = sqrt((mate[i].x-mate[i].px)*
			 (mate[i].x-mate[i].px)+
			 (mate[i].y-mate[i].py)*
			 (mate[i].y-mate[i].py)) / sec;

    Tr_mate[i].dir = DirFromXY__a( Tr_mate[i].x,
				   Tr_mate[i].y,
				   Tr_mate[i].dirx,
				   Tr_mate[i].diry );
    if( team_coat != S_LEFT){
      mate[i].dir = Tr_mate[i].dir;
    }
    else{
      mate[i].dir = (Tr_mate[i].dir<180)?
	Tr_mate[i].dir+180:Tr_mate[i].dir-180;
    }
    //printf("###[%d] : (%f,%f) speed:%f dir:%f\n",i,mate[i].x,mate[i].y,mate[i].speed,mate[i].dir);  
  }
  
  for(i=0;i<MAX_ENEMY_NO;i++){
    Tr_enemy[i].x  = Tr_enemy[i].x - (int)hosei_x(Tr_enemy[i].x);
    Tr_enemy[i].y  = Tr_enemy[i].y - (int)hosei_y(Tr_enemy[i].y);
    henkan(Tr_enemy[i].x , Tr_enemy[i].y , &enemy[i].x , &enemy[i].y);
    Tr_enemy[i].px  = Tr_enemy[i].px - (int)hosei_x(Tr_enemy[i].px);
    Tr_enemy[i].py  = Tr_enemy[i].py - (int)hosei_y(Tr_enemy[i].py);
    henkan(Tr_enemy[i].px , Tr_enemy[i].py , &enemy[i].px , &enemy[i].py);
    enemy[i].dir = 0;
  }
}


void henkan(double trx ,double try ,double *x ,double *y){

  if( trx < coat_left ) trx = coat_left;
  else if( trx > coat_right ) trx = coat_right;
  if( try < coat_high ) try = coat_high;
  else if( try > coat_bottom ) try = coat_bottom;
  if( team_coat == 0 ){
    *x = X_FIELD *( (trx-coat_left)/(coat_right-coat_left) );
    *y = Y_FIELD *( (try-coat_high)/(coat_bottom-coat_high) );
  }
  else{
    *x = 0.5+X_FIELD - (X_FIELD *( (trx-coat_left)/
			       (coat_right-coat_left) ));
    *y = 0.5+Y_FIELD -(Y_FIELD *( (try-coat_high)/
			      (coat_bottom-coat_high) ));
  }
  /*printf("# (%d,%d),(%f,%f)\n",trx,try,*x,*y);*/
}









